var sbro = sbro || {};

sbro._resetSnsBtn = function(selector) {
	var $target = $(selector);
	if($target.parent().hasClass('btn-sns')) {
		$target.unwrap();
	};
};

sbro._setOption = function($parent, options) {
	if (options) {
		if (options.size) {
			$parent.addClass(options.size);
		}
		if (options.threeD) {
			$parent.addClass('three-d');
		}
		if (options.width) {
			$parent.css('width', options.width);
		}
		if (options.height) {
			$parent.css('height', options.height);
		}
	}
}

sbro.toTwitterOAuth = function(selector, url, redirect, options) {
	sbro._resetSnsBtn(selector);
	var $target = $(selector);
	$target.wrap('<div class="btn-sns oauth btn-twitter"></div>');
	var $parent = $target.parents('.btn-sns');
	sbro._setOption($parent, options);
	$parent.on('click', function() {
		location.href = url + '?redirect=' + redirect;
	});
};

sbro.toFacebookOAuth = function(selector, url, redirect, options) {
	sbro._resetSnsBtn(selector);
	var $target = $(selector);
	$target.wrap('<div class="btn-sns oauth btn-facebook"></div>');
	var $parent = $target.parents('.btn-sns');
	sbro._setOption($parent, options);
	$parent.on('click', function() {
		location.href = url + '?redirect=' + redirect;
	});
};

sbro.toTweetShare = function(selector, title, url, hashTags, options) {
	sbro._resetSnsBtn(selector);
	var href = encodeURI('http://twitter.com/share?text=' + title + '&url=' + url);
	if (hashTags) {
		href += '&hashtags=' + hashTags;
	}
	var $target = $(selector);
	$target.wrap('<div class="btn-sns share btn-twitter"></div>');
	var $parent = $target.parents('.btn-sns');
	sbro._setOption($parent, options);
	$parent.on('click', function() {
		window.open(href);
	});
};

sbro.toFacebookShare = function(selector, title, url, options) {
	sbro._resetSnsBtn(selector);
	var href = encodeURI('http://www.facebook.com/sharer/sharer.php?t=' + title + '&u=' + url);
	var $target = $(selector);
	$target.wrap('<div class="btn-sns share btn-facebook"></div>');
	var $parent = $target.parents('.btn-sns');
	sbro._setOption($parent, options);
	$parent.on('click', function() {
		window.open(href, 'sharewindow', 'width=550, height=450, personalbar=0, toolbar=0, scrollbars=1, resizable=!');
	});
};

sbro.toGooglePlusShare = function(selector, title, url, options) {
	sbro._resetSnsBtn(selector);
	var href = encodeURI('https://plus.google.com/share?url=' + url);
	var $target = $(selector);
	$target.wrap('<div class="btn-sns share btn-google-plus"></div>');
	var $parent = $target.parents('.btn-sns');
	sbro._setOption($parent, options);
	$parent.on('click', function() {
		window.open(href, '', 'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=600,width=600');
	});
};

sbro.toLineShare = function(selector, title, url, options) {
	sbro._resetSnsBtn(selector);
	var href = encodeURI('line://msg/text/' + title + ' ' + url);
	var $target = $(selector);
	$target.wrap('<div class="btn-sns share btn-line"></div>');
	var $parent = $target.parents('.btn-sns');
	sbro._setOption($parent, options);
	$parent.on('click', function() {
		window.open(href).close();
	});
};
